"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lazyImplementation = exports.flatMap = void 0;
var flatten_1 = require("./flatten");
var purry_1 = require("./purry");
function flatMap() {
    return (0, purry_1.purry)(flatMapImplementation, arguments, exports.lazyImplementation);
}
exports.flatMap = flatMap;
function flatMapImplementation(data, callbackfn) {
    return (0, flatten_1.flatten)(data.map(callbackfn));
}
var lazyImplementation = function (callbackfn) {
    return function (value, index, data) {
        var next = callbackfn(value, index, data);
        return Array.isArray(next)
            ? { done: false, hasNext: true, hasMany: true, next: next }
            : { done: false, hasNext: true, next: next };
    };
};
exports.lazyImplementation = lazyImplementation;
