"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniqueBy = void 0;
var _reduceLazy_1 = require("./_reduceLazy");
var purry_1 = require("./purry");
function uniqueBy() {
    return (0, purry_1.purry)(uniqueByImplementation, arguments, lazyImplementation);
}
exports.uniqueBy = uniqueBy;
var uniqueByImplementation = function (data, keyFunction) { return (0, _reduceLazy_1._reduceLazy)(data, lazyImplementation(keyFunction)); };
function lazyImplementation(keyFunction) {
    var set = new Set();
    return function (value, index, data) {
        var key = keyFunction(value, index, data);
        if (set.has(key)) {
            return { done: false, hasNext: false };
        }
        set.add(key);
        return { done: false, hasNext: true, next: value };
    };
}
