import { flatten } from "./flatten";
import { purry } from "./purry";
export function flatMap() {
    return purry(flatMapImplementation, arguments, lazyImplementation);
}
function flatMapImplementation(data, callbackfn) {
    return flatten(data.map(callbackfn));
}
export var lazyImplementation = function (callbackfn) {
    return function (value, index, data) {
        var next = callbackfn(value, index, data);
        return Array.isArray(next)
            ? { done: false, hasNext: true, hasMany: true, next: next }
            : { done: false, hasNext: true, next: next };
    };
};
