import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function uniqueBy() {
    return purry(uniqueByImplementation, arguments, lazyImplementation);
}
var uniqueByImplementation = function (data, keyFunction) { return _reduceLazy(data, lazyImplementation(keyFunction)); };
function lazyImplementation(keyFunction) {
    var set = new Set();
    return function (value, index, data) {
        var key = keyFunction(value, index, data);
        if (set.has(key)) {
            return { done: false, hasNext: false };
        }
        set.add(key);
        return { done: false, hasNext: true, next: value };
    };
}
